import java.util.*;

public class SaturationComparator implements Comparator {

    public int compare(Object o1, Object o2){
	Vertex u = (Vertex) o1;
	Vertex v = (Vertex) o2;
	if (u.getSaturation() < v.getSaturation() || 
	    u.getSaturation() == v.getSaturation() && u.getDegree() < v.getDegree() ||
	    u.getSaturation() == v.getSaturation() && u.getDegree() == v.getDegree() && u.getIndex() < v.getIndex()) return 1;
	if (u.getSaturation() > v.getSaturation() || 
	    u.getSaturation() == v.getSaturation() && u.getDegree() > v.getDegree() ||
	    u.getSaturation() == v.getSaturation() && u.getDegree() == v.getDegree() && u.getIndex() > v.getIndex()) return -1;
	return 0;
    }
    //
    // to sort vertices by decreasing saturation
    //
}
